Copyright (c) <2023> <NTC CONTACT, Minsk, Belarus>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.


diff -ruN strongswan-5.8.4/configure.ac strongswancont-5.8.4-svc/configure.ac
--- strongswan-5.8.4/configure.ac	2020-03-29 13:49:52.000000000 +0300
+++ strongswancont-5.8.4-svc/configure.ac	2023-06-15 18:33:50.571474053 +0300
@@ -177,9 +177,9 @@
 ARG_DISBL_SET([sshkey],         [disable SSH key decoding plugin.])
 ARG_DISBL_SET([x509],           [disable X509 certificate implementation plugin.])
 # fetcher/resolver plugins
-ARG_ENABL_SET([curl],           [enable CURL fetcher plugin to fetch files via libcurl. Requires libcurl.])
+ARG_DISBL_SET([curl],           [disable CURL fetcher plugin to fetch files via libcurl. Requires libcurl.])
 ARG_ENABL_SET([files],          [enable simple file:// URI fetcher.])
-ARG_ENABL_SET([ldap],           [enable LDAP fetching plugin to fetch files via libldap. Requires openLDAP.])
+ARG_DISBL_SET([ldap],           [disable LDAP fetching plugin to fetch files via libldap. Requires openLDAP.])
 ARG_ENABL_SET([soup],           [enable soup fetcher plugin to fetch from HTTP via libsoup. Requires libsoup.])
 ARG_ENABL_SET([unbound],        [enable UNBOUND resolver plugin to perform DNS queries via libunbound. Requires libldns and libunbound.])
 ARG_ENABL_SET([winhttp],        [enable WinHTTP based HTTP/HTTPS fetching plugin.])
@@ -189,7 +189,7 @@
 # authentication/credential plugins
 ARG_ENABL_SET([addrblock],      [enables RFC 3779 address block constraint support.])
 ARG_ENABL_SET([acert],          [enable X509 attribute certificate checking plugin.])
-ARG_ENABL_SET([agent],          [enables the ssh-agent signing plugin.])
+ARG_DISBL_SET([agent],          [disable the ssh-agent signing plugin.])
 ARG_DISBL_SET([constraints],    [disable advanced X509 constraint checking plugin.])
 ARG_ENABL_SET([coupling],       [enable IKEv2 plugin to couple peer certificates permanently to authentication.])
 ARG_ENABL_SET([dnscert],        [enable DNSCERT authentication plugin.])
@@ -202,7 +202,7 @@
 ARG_ENABL_SET([eap-simaka-sql], [enable EAP-SIM/AKA backend based on a triplet/quintuplet SQL database.])
 ARG_ENABL_SET([eap-simaka-pseudonym], [enable EAP-SIM/AKA pseudonym storage plugin.])
 ARG_ENABL_SET([eap-simaka-reauth],    [enable EAP-SIM/AKA reauthentication data storage plugin.])
-ARG_ENABL_SET([eap-identity],   [enable EAP module providing EAP-Identity helper.])
+ARG_DISBL_SET([eap-identity],   [disable EAP module providing EAP-Identity helper.])
 ARG_ENABL_SET([eap-md5],        [enable EAP MD5 (CHAP) authentication module.])
 ARG_ENABL_SET([eap-gtc],        [enable EAP GTC authentication module.])
 ARG_ENABL_SET([eap-mschapv2],   [enable EAP MS-CHAPv2 authentication module.])
@@ -228,7 +228,7 @@
 ARG_ENABL_SET([kernel-pfkey],   [enable the PF_KEY kernel interface.])
 ARG_ENABL_SET([kernel-pfroute], [enable the PF_ROUTE kernel interface.])
 ARG_ENABL_SET([kernel-iph],     [enable the Windows IP Helper based networking backend.])
-ARG_ENABL_SET([kernel-libipsec],[enable the libipsec kernel interface.])
+ARG_DISBL_SET([kernel-libipsec],[disable the libipsec kernel interface.])
 ARG_ENABL_SET([kernel-wfp],     [enable the Windows Filtering Platform IPsec backend.])
 ARG_DISBL_SET([socket-default], [disable default socket implementation for charon.])
 ARG_ENABL_SET([socket-dynamic], [enable dynamic socket implementation for charon])
@@ -243,7 +243,7 @@
 ARG_ENABL_SET([android-dns],    [enable Android specific DNS handler.])
 ARG_DISBL_SET([attr],           [disable strongswan.conf based configuration attribute plugin.])
 ARG_ENABL_SET([attr-sql],       [enable SQL based configuration attribute plugin.])
-ARG_ENABL_SET([dhcp],           [enable DHCP based attribute provider plugin.])
+ARG_DISBL_SET([dhcp],           [disable DHCP based attribute provider plugin.])
 ARG_ENABL_SET([osx-attr],       [enable OS X SystemConfiguration attribute handler.])
 ARG_ENABL_SET([p-cscf],         [enable plugin to request P-CSCF server addresses from an ePDG.])
 ARG_DISBL_SET([resolve],        [disable resolve DNS handler plugin.])
@@ -298,7 +298,7 @@
 ARG_ENABL_SET([manager],        [enable web management console (proof of concept).])
 ARG_ENABL_SET([medcli],         [enable mediation client configuration database plugin.])
 ARG_ENABL_SET([medsrv],         [enable mediation server web frontend and daemon plugin.])
-ARG_ENABL_SET([nm],             [enable NetworkManager backend.])
+ARG_DISBL_SET([nm],             [disable NetworkManager backend.])
 ARG_DISBL_SET([pki],            [disable pki certificate utility.])
 ARG_DISBL_SET([scepclient],     [disable SCEP client tool.])
 ARG_DISBL_SET([scripts],        [disable additional utilities (found in directory scripts).])
@@ -330,6 +330,7 @@
 ARG_ENABL_SET([lock-profiler],  [enable lock/mutex profiling code.])
 ARG_ENABL_SET([log-thread-ids], [use thread ID, if available, instead of an incremented value starting from 1, to identify threads.])
 ARG_ENABL_SET([monolithic],     [build monolithic version of libstrongswan that includes all enabled plugins. Similarly, the plugins of charon are assembled in libcharon.])
+ARG_ENABL_SET([wintun],         [enable wintun TUN driver support.])
 
 # ===================================
 #  option to disable default options
@@ -1477,7 +1478,7 @@
 ADD_PLUGIN([attr],                 [c charon])
 ADD_PLUGIN([attr-sql],             [c charon])
 ADD_PLUGIN([load-tester],          [c charon])
-ADD_PLUGIN([kernel-libipsec],      [c charon cmd])
+ADD_PLUGIN([kernel-libipsec],      [c charon nm cmd])
 ADD_PLUGIN([kernel-wfp],           [c charon])
 ADD_PLUGIN([kernel-iph],           [c charon])
 ADD_PLUGIN([kernel-pfkey],         [c charon starter nm cmd])
@@ -1530,7 +1531,7 @@
 ADD_PLUGIN([tnccs-dynamic],        [t charon])
 ADD_PLUGIN([medsrv],               [c charon])
 ADD_PLUGIN([medcli],               [c charon])
-ADD_PLUGIN([dhcp],                 [c charon])
+ADD_PLUGIN([dhcp],                 [c charon nm cmd])
 ADD_PLUGIN([osx-attr],             [c charon cmd])
 ADD_PLUGIN([p-cscf],               [c charon cmd])
 ADD_PLUGIN([android-dns],          [c charon])
@@ -1786,6 +1787,7 @@
 AM_CONDITIONAL(USE_PERL_CPAN, test x$perl_cpan = xtrue)
 AM_CONDITIONAL(USE_TOX, test "x$TOX" != x)
 AM_CONDITIONAL(USE_PY_TEST, test "x$PY_TEST" != x -a "x$TOX" = x)
+AM_CONDITIONAL(USE_WINTUN, test "x$wintun" != x)
 
 # ========================
 #  set global definitions
@@ -1818,6 +1820,9 @@
 if test x$imc_swima = xtrue -o x$imv_swima = xtrue; then
 	AC_DEFINE([USE_JSON], [], [build code for JSON])
 fi
+if test x$wintun = xtrue; then
+	AC_DEFINE([USE_WINTUN], [], [Build in wintun TUN driver support])
+fi
 
 # ====================================================
 #  options for enabled modules (see conf/Makefile.am)
@@ -1839,6 +1844,7 @@
 AM_COND_IF([USE_PKI], [strongswan_options=${strongswan_options}" pki"])
 AM_COND_IF([USE_SWANCTL], [strongswan_options=${strongswan_options}" swanctl"])
 AM_COND_IF([USE_SYSTEMD], [strongswan_options=${strongswan_options}" charon-systemd"])
+#AM_COND_IF([USE_SVC], [strongswan_options=${strongswan_options}" charon-svc"])
 
 AC_SUBST(strongswan_options)
 
diff -ruN strongswan-5.8.4/src/charon/charon.c strongswancont-5.8.4-svc/src/charon/charon.c
--- strongswan-5.8.4/src/charon/charon.c	2019-08-27 16:26:53.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon/charon.c	2022-07-06 15:47:33.738966000 +0300
@@ -366,6 +366,7 @@
 			{ "debug-tls", required_argument, &group, DBG_TLS },
 			{ "debug-esp", required_argument, &group, DBG_ESP },
 			{ "debug-lib", required_argument, &group, DBG_LIB },
+			{ "debug-cnt", required_argument, &group, DBG_CNT },
 			{ 0,0,0,0 }
 		};
 
@@ -379,7 +380,7 @@
 				status = 0;
 				goto deinit;
 			case 'v':
-				printf("Linux strongSwan %s\n", VERSION);
+				printf("Linux strongSwanCont %s\n", VERSION);
 				status = 0;
 				goto deinit;
 			case 'l':
@@ -410,7 +411,7 @@
 	{
 		memset(&utsname, 0, sizeof(utsname));
 	}
-	DBG1(DBG_DMN, "Starting IKE charon daemon (strongSwan "VERSION", %s %s, %s)",
+	DBG1(DBG_DMN, "Starting IKE charon daemon (STC CONTACT "VERSION", %s %s, %s)",
 		  utsname.sysname, utsname.release, utsname.machine);
 	if (lib->integrity)
 	{
diff -ruN strongswan-5.8.4/src/charon-nm/charon-nm.c strongswancont-5.8.4-svc/src/charon-nm/charon-nm.c
--- strongswan-5.8.4/src/charon-nm/charon-nm.c	2020-03-29 12:01:12.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon-nm/charon-nm.c	2022-07-06 15:47:33.746967000 +0300
@@ -200,7 +200,7 @@
 	lib->settings->set_default_str(lib->settings, "charon-nm.port", "0");
 	lib->settings->set_default_str(lib->settings, "charon-nm.port_nat_t", "0");
 
-	DBG1(DBG_DMN, "Starting charon NetworkManager backend (strongSwan "VERSION")");
+	DBG1(DBG_DMN, "Starting charon NetworkManager backend (strongSwanCont "VERSION")");
 	if (lib->integrity)
 	{
 		DBG1(DBG_DMN, "integrity tests enabled:");
diff -ruN strongswan-5.8.4/src/charon-nm/Makefile.am strongswancont-5.8.4-svc/src/charon-nm/Makefile.am
--- strongswan-5.8.4/src/charon-nm/Makefile.am	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon-nm/Makefile.am	2022-07-06 15:47:33.746967000 +0300
@@ -23,6 +23,6 @@
 	$(top_builddir)/src/libcharon/libcharon.la \
 	-lm $(PTHREADLIB) $(ATOMICLIB) $(DLLIB) ${nm_LIBS}
 
-dbuspolicy_DATA = nm-strongswan-service.conf
+dbuspolicy_DATA = nm-strongswancont-service.conf
 
 EXTRA_DIST = $(dbuspolicy_DATA)
diff -ruN strongswan-5.8.4/src/charon-nm/nm/nm_creds.c strongswancont-5.8.4-svc/src/charon-nm/nm/nm_creds.c
--- strongswan-5.8.4/src/charon-nm/nm/nm_creds.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon-nm/nm/nm_creds.c	2022-07-06 15:47:33.746967000 +0300
@@ -41,6 +41,11 @@
 	linked_list_t *certs;
 
 	/**
+	 * List of revocation lists, certificate_t*
+	 */
+	linked_list_t *crls;
+
+	/**
 	 * User name
 	 */
 	identification_t *user;
@@ -77,6 +82,17 @@
 };
 
 /**
+ * Enumerator for revocation lists
+ */
+static enumerator_t *create_crl_enumerator(private_nm_creds_t *this)
+{
+	this->lock->read_lock(this->lock);
+	return enumerator_create_cleaner(this->crls->create_enumerator(this->crls),
+							(void*)this->lock->unlock, this->lock);
+
+}
+
+/**
  * Enumerator for user certificate
  */
 static enumerator_t *create_usercert_enumerator(private_nm_creds_t *this,
@@ -198,6 +214,10 @@
 	{
 		return create_trusted_cert_enumerator(this, key, id);
 	}
+	if (cert == CERT_X509_CRL)
+	{
+		return create_crl_enumerator(this);
+	}
 	return NULL;
 }
 
@@ -389,6 +409,56 @@
 	}
 }
 
+/**
+ * Load a CRL file
+ */
+static void load_crl_file(private_nm_creds_t *this, char *file)
+{
+	certificate_t *cert;
+
+	/* We add the CA constraint, as many CAs miss it */
+	cert = lib->creds->create(lib->creds, CRED_CERTIFICATE, CERT_X509_CRL,
+							  BUILD_FROM_FILE, file, BUILD_END);
+	if (!cert)
+	{
+		DBG1(DBG_CFG, "loading CRL '%s' failed", file);
+	}
+	else
+	{
+		DBG2(DBG_CFG, "loaded CRL '%s'", file);
+		this->crls->insert_last(this->crls, cert);
+	}
+}
+
+METHOD(nm_creds_t, load_crl_dir, void,
+	private_nm_creds_t *this, char *dir)
+{
+	enumerator_t *enumerator;
+	char *rel, *abs;
+	struct stat st;
+
+	enumerator = enumerator_create_directory(dir);
+	if (enumerator)
+	{
+		while (enumerator->enumerate(enumerator, &rel, &abs, &st))
+		{
+			/* skip '.', '..' and hidden files */
+			if (rel[0] != '.')
+			{
+				if (S_ISDIR(st.st_mode))
+				{
+					load_crl_dir(this, abs);
+				}
+				else if (S_ISREG(st.st_mode))
+				{
+					load_crl_file(this, abs);
+				}
+			}
+		}
+		enumerator->destroy(enumerator);
+	}
+}
+
 METHOD(nm_creds_t, set_username_password, void,
 	private_nm_creds_t *this, identification_t *id, char *password)
 {
@@ -440,6 +510,10 @@
 	{
 		cert->destroy(cert);
 	}
+	while (this->crls->remove_last(this->crls, (void**)&cert) == SUCCESS)
+	{
+		cert->destroy(cert);
+	}
 	DESTROY_IF(this->user);
 	free(this->pass);
 	free(this->keypass);
@@ -459,6 +533,7 @@
 {
 	clear(this);
 	this->certs->destroy(this->certs);
+	this->crls->destroy(this->crls);
 	this->lock->destroy(this->lock);
 	free(this);
 }
@@ -481,6 +556,7 @@
 			},
 			.add_certificate = _add_certificate,
 			.load_ca_dir = _load_ca_dir,
+			.load_crl_dir = _load_crl_dir,
 			.set_username_password = _set_username_password,
 			.set_key_password = _set_key_password,
 			.set_pin = _set_pin,
@@ -490,6 +566,7 @@
 		},
 		.lock = rwlock_create(RWLOCK_TYPE_DEFAULT),
 		.certs = linked_list_create(),
+		.crls = linked_list_create(),
 	);
 	return &this->public;
 }
diff -ruN strongswan-5.8.4/src/charon-nm/nm/nm_creds.h strongswancont-5.8.4-svc/src/charon-nm/nm/nm_creds.h
--- strongswan-5.8.4/src/charon-nm/nm/nm_creds.h	2018-10-04 00:35:16.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon-nm/nm/nm_creds.h	2022-07-06 15:47:33.746967000 +0300
@@ -51,6 +51,13 @@
 	void (*load_ca_dir)(nm_creds_t *this, char *dir);
 
 	/**
+	 * Load CRLs recursively from a directory.
+	 *
+	 * @param dir		directory to CRLs
+	 */
+	void (*load_crl_dir)(nm_creds_t *this, char *dir);
+
+	/**
 	 * Set the username/password for authentication.
 	 *
 	 * @param id		ID of the user
diff -ruN strongswan-5.8.4/src/charon-nm/nm/nm_service.c strongswancont-5.8.4-svc/src/charon-nm/nm/nm_service.c
--- strongswan-5.8.4/src/charon-nm/nm/nm_service.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon-nm/nm/nm_service.c	2022-07-06 15:47:33.746967000 +0300
@@ -307,22 +307,12 @@
 	NMStrongswanPluginPrivate *this, ike_sa_t *ike_sa, child_sa_t *child_sa,
 	bool up)
 {
-	if (this->ike_sa == ike_sa)
+	if (this->ike_sa == ike_sa && up)
 	{
-		if (up)
-		{	/* disable initiate-failure-detection hooks */
-			this->listener.ike_state_change = NULL;
-			this->listener.child_state_change = NULL;
-			signal_ip_config(this->plugin, ike_sa, child_sa);
-		}
-		else
-		{
-			if (ike_sa->has_condition(ike_sa, COND_REAUTHENTICATING))
-			{	/* we ignore this during reauthentication */
-				return TRUE;
-			}
-			signal_failure(this->plugin, NM_VPN_PLUGIN_FAILURE_CONNECT_FAILED);
-		}
+		/* disable initiate-failure-detection hooks */
+		this->listener.ike_state_change = NULL;
+		this->listener.child_state_change = NULL;
+		signal_ip_config(this->plugin, ike_sa, child_sa);
 	}
 	return TRUE;
 }
@@ -390,10 +380,11 @@
 	identification_t *id = NULL;
 	certificate_t *cert = NULL;
 	auth_cfg_t *auth;
-	const char *str, *method, *cert_source;
+	const char *str, *method, *cert_source,  *userkey_source;
 
 	method = nm_setting_vpn_get_data_item(vpn, "method");
 	cert_source = nm_setting_vpn_get_data_item(vpn, "cert-source") ?: method;
+	userkey_source = nm_setting_vpn_get_data_item(vpn, "userkey-source");
 
 	if (streq(cert_source, "smartcard"))
 	{
@@ -450,19 +441,42 @@
 							"Connecting to SSH agent failed.");
 			}
 		}
+		/* ... or usbbar */
+		if (streq(userkey_source, "usbbar")) 
+		{
+			char *secret;
+			secret = (char*)nm_setting_vpn_get_secret(vpn, "password");
+			private = lib->creds->create(lib->creds, CRED_PRIVATE_KEY,
+							KEY_ANY, BUILD_USBBAR_PWD, secret, BUILD_END);
+			if (!private)
+			{
+				g_set_error(err, NM_VPN_PLUGIN_ERROR,
+							NM_VPN_PLUGIN_ERROR_BAD_ARGUMENTS,
+							"Loading private key failed.");
+			}
+		}
 		/* ... or key file */
 		str = nm_setting_vpn_get_data_item(vpn, "userkey");
 		if (!agent && str)
 		{
 			char *secret;
-
 			secret = (char*)nm_setting_vpn_get_secret(vpn, "password");
-			if (secret)
+			if (streq(userkey_source, "bpki"))
 			{
-				priv->creds->set_key_password(priv->creds, secret);
-			}
-			private = lib->creds->create(lib->creds, CRED_PRIVATE_KEY,
+				const char *params = nm_setting_vpn_get_data_item(vpn, "bpki-params");
+				if (params)
+				{
+					char params_with_pwd[2048] = {0};
+					sprintf(params_with_pwd, "%s PWD=\"%s\"", params, secret);
+					private = lib->creds->create(lib->creds, CRED_PRIVATE_KEY,
+									KEY_BIGN, BUILD_BPKI_PARAMS, chunk_from_str(params_with_pwd), BUILD_END);
+				}				
+			}			
+			else
+			{
+				private = lib->creds->create(lib->creds, CRED_PRIVATE_KEY,
 									KEY_ANY, BUILD_FROM_FILE, str, BUILD_END);
+			}
 			if (!private)
 			{
 				g_set_error(err, NM_VPN_PLUGIN_ERROR,
@@ -497,6 +511,11 @@
 		auth->add(auth, AUTH_RULE_AAA_IDENTITY,
 				  identification_create_from_string("%any"));
 	}
+	else if (streq(method, "eap-bsts"))
+	{
+		auth->add(auth, AUTH_RULE_AUTH_CLASS, AUTH_CLASS_EAP);
+		auth->add(auth, AUTH_RULE_EAP_TYPE, EAP_BSTS);		
+	}
 	else
 	{
 		auth->add(auth, AUTH_RULE_AUTH_CLASS, AUTH_CLASS_PUBKEY);
@@ -608,6 +627,7 @@
 	certificate_t *cert = NULL;
 	x509_t *x509;
 	bool loose_gateway_id = FALSE;
+	int32_t custom_dpd = 0;
 	ike_cfg_create_t ike = {
 		.version = IKEV2,
 		.local = "%any",
@@ -618,7 +638,6 @@
 	peer_cfg_create_t peer = {
 		.cert_policy = CERT_SEND_IF_ASKED,
 		.unique = UNIQUE_REPLACE,
-		.keyingtries = 1,
 		.rekey_time = 36000, /* 10h */
 		.jitter_time = 600, /* 10min */
 		.over_time = 600, /* 10min */
@@ -630,8 +649,15 @@
 				.rekey = 10200 /* 2h50min */,
 				.jitter = 300 /* 5min */
 			},
+			.bytes = {
+				.life = 11000000000000 /* ~10TB */,
+				.rekey = 10000000000000 /* ~9TB */,
+				.jitter = 1000000000000 /* ~1TB */
+			},
 		},
 		.mode = MODE_TUNNEL,
+		.dpd_action = ACTION_RESTART,
+		.close_action = ACTION_RESTART,
 	};
 
 	/**
@@ -670,11 +696,28 @@
 	str = nm_setting_vpn_get_data_item(vpn, "ipcomp");
 	child.options |= streq(str, "yes") ? OPT_IPCOMP : 0;
 
+	// dpd
+	str = nm_setting_vpn_get_data_item(vpn, "dpd-delay");
+	if (str && strlen(str))
+	{
+		if ( (custom_dpd = atoi(str)) > 0)
+		{
+			peer.dpd = custom_dpd;
+		}
+	}
+
 	/**
 	 * Register credentials
 	 */
 	priv->creds->clear(priv->creds);
 
+	/* preinstalled CRLs */
+	str = nm_setting_vpn_get_data_item(vpn, "crl-dir");
+	if (str && strlen(str))
+	{
+		priv->creds->load_crl_dir(priv->creds, str);
+	}
+
 	/* gateway/CA cert */
 	str = nm_setting_vpn_get_data_item(vpn, "certificate");
 	if (str)
@@ -766,7 +809,8 @@
 		streq(method, "eap-tls") ||
 		streq(method, "key") ||
 		streq(method, "agent") ||
-		streq(method, "smartcard"))
+		streq(method, "smartcard") ||
+		streq(method, "eap-bsts"))
 	{
 		if (!add_auth_cfg_cert (priv, vpn, peer_cfg, err))
 		{
@@ -777,7 +821,8 @@
 		}
 	}
 	else if (streq(method, "eap") ||
-			 streq(method, "psk"))
+			 streq(method, "psk") ||
+			 streq(method, "eap-bpace"))
 	{
 		if (!add_auth_cfg_pw(priv, vpn, peer_cfg, err))
 		{
@@ -839,10 +884,34 @@
 	}
 	ts = traffic_selector_create_dynamic(0, 0, 65535);
 	child_cfg->add_traffic_selector(child_cfg, TRUE, ts);
-	ts = traffic_selector_create_from_cidr("0.0.0.0/0", 0, 0, 65535);
-	child_cfg->add_traffic_selector(child_cfg, FALSE, ts);
-	ts = traffic_selector_create_from_cidr("::/0", 0, 0, 65535);
-	child_cfg->add_traffic_selector(child_cfg, FALSE, ts);
+	str = nm_setting_vpn_get_data_item(vpn, "remote-ts");
+	if (str && strlen(str))
+	{
+		enumerator = enumerator_create_token(str, ";", "");
+		while (enumerator->enumerate(enumerator, &str))
+		{
+			ts = traffic_selector_create_from_cidr((char*)str, 0, 0, 65535);
+			if (!ts)
+			{
+				g_set_error(err, NM_VPN_PLUGIN_ERROR,
+							NM_VPN_PLUGIN_ERROR_LAUNCH_FAILED,
+							"Invalid remote traffic selector.");
+				enumerator->destroy(enumerator);
+				child_cfg->destroy(child_cfg);
+				peer_cfg->destroy(peer_cfg);
+				return FALSE;
+			}
+			child_cfg->add_traffic_selector(child_cfg, FALSE, ts);
+		}
+		enumerator->destroy(enumerator);
+	}
+	else
+	{
+		ts = traffic_selector_create_from_cidr("0.0.0.0/0", 0, 0, 65535);
+		child_cfg->add_traffic_selector(child_cfg, FALSE, ts);
+		ts = traffic_selector_create_from_cidr("::/0", 0, 0, 65535);
+		child_cfg->add_traffic_selector(child_cfg, FALSE, ts);
+	}
 	peer_cfg->add_child_cfg(peer_cfg, child_cfg);
 
 	/**
@@ -893,7 +962,7 @@
 							 const char **setting_name, GError **error)
 {
 	NMSettingVpn *settings;
-	const char *method, *cert_source, *path;
+	const char *method, *cert_source, *userkey_source, *path;
 	bool need_secret = FALSE;
 
 	settings = NM_SETTING_VPN(nm_connection_get_setting(connection,
@@ -905,9 +974,11 @@
 			streq(method, "eap-tls") ||
 			streq(method, "key") ||
 			streq(method, "agent") ||
-			streq(method, "smartcard"))
+			streq(method, "smartcard") ||
+			streq(method, "eap-bsts"))
 		{
 			cert_source = nm_setting_vpn_get_data_item(settings, "cert-source");
+			userkey_source = nm_setting_vpn_get_data_item(settings, "userkey-source");
 			if (!cert_source)
 			{
 				cert_source = method;
@@ -920,6 +991,10 @@
 			{
 				need_secret = !nm_setting_vpn_get_secret(settings, "password");
 			}
+			else if (userkey_source)
+			{
+				need_secret = !nm_setting_vpn_get_secret(settings, "password");
+			}
 			else
 			{
 				need_secret = TRUE;
@@ -944,7 +1019,8 @@
 			}
 		}
 		else if (streq(method, "eap") ||
-				 streq(method, "psk"))
+				 streq(method, "psk") ||
+				 streq(method, "eap-bpace"))
 		{
 			need_secret = !nm_setting_vpn_get_secret(settings, "password");
 		}
@@ -974,6 +1050,11 @@
 			enumerator->destroy(enumerator);
 			charon->controller->terminate_ike(charon->controller, id, FALSE,
 											  controller_cb_empty, NULL, 0);
+
+			/* clear secrets as we are asked for new secrets (where we'd find
+			 * the cached secrets from earlier connections) before we clear
+			 * them in connect() */
+			priv->creds->clear(priv->creds);
 			return FALSE;
 		}
 	}
diff -ruN strongswan-5.8.4/src/charon-nm/nm/nm_service.h strongswancont-5.8.4-svc/src/charon-nm/nm/nm_service.h
--- strongswan-5.8.4/src/charon-nm/nm/nm_service.h	2018-10-04 00:35:16.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon-nm/nm/nm_service.h	2022-07-06 15:47:33.746967000 +0300
@@ -35,9 +35,9 @@
 #define NM_IS_STRONGSWAN_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((obj), NM_TYPE_STRONGSWAN_PLUGIN))
 #define NM_STRONGSWAN_PLUGIN_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), NM_TYPE_STRONGSWAN_PLUGIN, NMStrongswanPluginClass))
 
-#define NM_DBUS_SERVICE_STRONGSWAN    "org.freedesktop.NetworkManager.strongswan"
-#define NM_DBUS_INTERFACE_STRONGSWAN  "org.freedesktop.NetworkManager.strongswan"
-#define NM_DBUS_PATH_STRONGSWAN       "/org/freedesktop/NetworkManager/strongswan"
+#define NM_DBUS_SERVICE_STRONGSWAN    "org.freedesktop.NetworkManager.strongswancont"
+#define NM_DBUS_INTERFACE_STRONGSWAN  "org.freedesktop.NetworkManager.strongswancont"
+#define NM_DBUS_PATH_STRONGSWAN       "/org/freedesktop/NetworkManager/strongswancont"
 
 typedef struct {
 	NMVpnServicePlugin parent;
diff -ruN strongswan-5.8.4/src/charon-nm/nm-strongswancont-service.conf strongswancont-5.8.4-svc/src/charon-nm/nm-strongswancont-service.conf
--- strongswan-5.8.4/src/charon-nm/nm-strongswancont-service.conf	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon-nm/nm-strongswancont-service.conf	2022-07-06 15:47:33.758967000 +0300
@@ -0,0 +1,15 @@
+<!DOCTYPE busconfig PUBLIC
+ "-//freedesktop//DTD D-BUS Bus Configuration 1.0//EN"
+ "http://www.freedesktop.org/standards/dbus/1.0/busconfig.dtd">
+<busconfig>
+	<policy user="root">
+		<allow own="org.freedesktop.NetworkManager.strongswancont"/>
+		<allow send_destination="org.freedesktop.NetworkManager.strongswancont"/>
+		<allow send_interface="org.freedesktop.NetworkManager.strongswancont"/>
+	</policy>
+	<policy context="default">
+		<deny own="org.freedesktop.NetworkManager.strongswancont"/>
+		<deny send_destination="org.freedesktop.NetworkManager.strongswancont"/>
+	</policy>
+</busconfig>
+
diff -ruN strongswan-5.8.4/src/charon-svc/charon-svc.c strongswancont-5.8.4-svc/src/charon-svc/charon-svc.c
--- strongswan-5.8.4/src/charon-svc/charon-svc.c	2018-05-28 14:30:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/charon-svc/charon-svc.c	2022-12-08 15:26:17.088850000 +0300
@@ -68,7 +68,7 @@
 }
 
 /**
- * Log strongSwan/Windows version during startup
+ * Log strongSwanCont/Windows version during startup
  */
 static void print_version()
 {
@@ -79,7 +79,7 @@
 
 	if (GetVersionEx((LPOSVERSIONINFO)&osvie))
 	{
-		DBG1(DBG_DMN, "Starting IKE service %s (strongSwan %s, "
+		DBG1(DBG_DMN, "Starting IKE service %s (strongSwanCont %s, "
 			 "Windows %s %d.%d.%d (SP %d.%d)", SERVICE_NAME, VERSION,
 			 osvie.wProductType == VER_NT_WORKSTATION ? "Client" : "Server",
 			 osvie.dwMajorVersion, osvie.dwMinorVersion, osvie.dwBuildNumber,
Двоичные файлы strongswan-5.8.4/src/charon-svc/charon-svc.exe и strongswancont-5.8.4-svc/src/charon-svc/charon-svc.exe различаются
diff -ruN strongswan-5.8.4/src/include/linux/pfkeyv2.h strongswancont-5.8.4-svc/src/include/linux/pfkeyv2.h
--- strongswan-5.8.4/src/include/linux/pfkeyv2.h	2016-04-22 23:01:35.000000000 +0300
+++ strongswancont-5.8.4-svc/src/include/linux/pfkeyv2.h	2022-07-06 15:47:33.766967000 +0300
@@ -296,6 +296,10 @@
 #define SADB_X_AALG_SHA2_512HMAC	7
 #define SADB_X_AALG_RIPEMD160HMAC	8
 #define SADB_X_AALG_AES_XCBC_MAC	9
+#define SADB_X_AALG_BELT_HASH		10
+#define SADB_X_AALG_GOST_MAC		11
+#define SADB_X_AALG_BELT_MAC		12
+#define SADB_X_AALG_BELT_HMAC		13
 #define SADB_X_AALG_NULL		251	/* kame */
 #define SADB_AALG_MAX			251
 
@@ -316,6 +320,13 @@
 #define SADB_X_EALG_AES_GCM_ICV16	20
 #define SADB_X_EALG_CAMELLIACBC		22
 #define SADB_X_EALG_NULL_AES_GMAC	23
+#define SADB_X_EALG_GOST28147_ECB	24
+#define SADB_X_EALG_GOST28147_CTR	25
+#define SADB_X_EALG_GOST28147_CFB	26 
+#define SADB_X_EALG_BELT_ECB		27 
+#define SADB_X_EALG_BELT_CBC		28 
+#define SADB_X_EALG_BELT_CFB		29 
+#define SADB_X_EALG_BELT_CTR		30 
 #define SADB_EALG_MAX                   253 /* last EALG */
 /* private allocations should use 249-255 (RFC2407) */
 #define SADB_X_EALG_SERPENTCBC  252     /* draft-ietf-ipsec-ciph-aes-cbc-00 */
diff -ruN strongswan-5.8.4/src/ipsec/_ipsec.8.in strongswancont-5.8.4-svc/src/ipsec/_ipsec.8.in
--- strongswan-5.8.4/src/ipsec/_ipsec.8.in	2018-10-23 20:03:28.000000000 +0300
+++ strongswancont-5.8.4-svc/src/ipsec/_ipsec.8.in	2022-07-06 15:47:33.782967000 +0300
@@ -1,4 +1,4 @@
-.TH @IPSEC_SCRIPT_UPPER@ 8 "2013-10-29" "@IPSEC_VERSION@" "strongSwan"
+.TH @IPSEC_SCRIPT_UPPER@ 8 "2013-10-29" "@IPSEC_VERSION@" "strongSwanCont"
 .
 .SH NAME
 .
@@ -277,15 +277,15 @@
 .TP
 .B "\-\-version"
 returns the version in the form of
-.B Linux strongSwan U<strongSwan userland version>/K<Linux kernel version>
-if strongSwan uses the native NETKEY IPsec stack of the Linux kernel it is
+.B Linux strongSwanCont U<strongSwanCont userland version>/K<Linux kernel version>
+if strongSwanCont uses the native NETKEY IPsec stack of the Linux kernel it is
 running on.
 .
 .TP
 .B "\-\-versioncode"
 returns the version number in the form of
-.B U<strongSwan userland version>/K<Linux kernel version>
-if strongSwan uses the native NETKEY IPsec stack of the Linux kernel it is
+.B U<strongSwanCont userland version>/K<Linux kernel version>
+if strongSwanCont uses the native NETKEY IPsec stack of the Linux kernel it is
 running on.
 .
 .TP
diff -ruN strongswan-5.8.4/src/ipsec/_ipsec.in strongswancont-5.8.4-svc/src/ipsec/_ipsec.in
--- strongswan-5.8.4/src/ipsec/_ipsec.in	2019-08-27 16:27:26.000000000 +0300
+++ strongswancont-5.8.4-svc/src/ipsec/_ipsec.in	2022-07-06 15:47:33.782967000 +0300
@@ -42,7 +42,7 @@
 
 export IPSEC_DIR IPSEC_BINDIR IPSEC_SBINDIR IPSEC_CONFDIR IPSEC_PIDDIR IPSEC_SCRIPT IPSEC_VERSION IPSEC_NAME IPSEC_STARTER_PID IPSEC_CHARON_PID
 
-IPSEC_DISTRO="University of Applied Sciences Rapperswil, Switzerland"
+IPSEC_DISTRO="STC Contact\nMinsk, Belarus"
 
 command_dir="$IPSEC_DIR"
 
@@ -171,10 +171,10 @@
 	rc=7
 	if [ -e $IPSEC_STARTER_PID ]
 	then
-		echo "Reloading strongSwan IPsec configuration..." >&2
+		echo "Reloading strongSwanCont IPsec configuration..." >&2
 		kill -USR1 `cat $IPSEC_STARTER_PID` 2>/dev/null && rc=0
 	else
-		echo "Reloading strongSwan IPsec failed: starter is not running" >&2
+		echo "Reloading strongSwanCont IPsec failed: starter is not running" >&2
 	fi
 	exit "$rc"
 	;;
@@ -249,7 +249,7 @@
 	# stopping a not-running service is considered as success
 	if [ -e $IPSEC_STARTER_PID ]
 	then
-		echo "Stopping strongSwan IPsec..." >&2
+		echo "Stopping strongSwanCont IPsec..." >&2
 		spid=`cat $IPSEC_STARTER_PID`
 		if [ -n "$spid" ]
 		then
@@ -272,7 +272,7 @@
 			fi
 		fi
 	else
-		echo "Stopping strongSwan IPsec failed: starter is not running" >&2
+		echo "Stopping strongSwanCont IPsec failed: starter is not running" >&2
 	fi
 	if [ -d /var/lock/subsys ]; then
 		rm -f /var/lock/subsys/ipsec
@@ -297,11 +297,11 @@
 update)
 	if [ -e $IPSEC_STARTER_PID ]
 	then
-		echo "Updating strongSwan IPsec configuration..." >&2
+		echo "Updating strongSwanCont IPsec configuration..." >&2
 		kill -HUP `cat $IPSEC_STARTER_PID`
 		exit 0
 	else
-		echo "Updating strongSwan IPsec failed: starter is not running" >&2
+		echo "Updating strongSwanCont IPsec failed: starter is not running" >&2
 		exit 7
 	fi
 	;;
diff -ruN strongswan-5.8.4/src/libcharon/bus/listeners/file_logger.c strongswancont-5.8.4-svc/src/libcharon/bus/listeners/file_logger.c
--- strongswan-5.8.4/src/libcharon/bus/listeners/file_logger.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/bus/listeners/file_logger.c	2022-07-06 15:47:33.786967000 +0300
@@ -243,6 +243,25 @@
 				 this->filename, strerror(errno));
 			return;
 		}
+#ifdef HAVE_CHOWN
+		if (lib->caps->check(lib->caps, CAP_CHOWN))
+		{
+			if (chown(this->filename, lib->caps->get_uid(lib->caps),
+					  lib->caps->get_gid(lib->caps)) != 0)
+			{
+				DBG1(DBG_NET, "changing owner/group for '%s' failed: %s",
+					 this->filename, strerror(errno));
+			}
+		}
+		else
+		{
+			if (chown(this->filename, -1, lib->caps->get_gid(lib->caps)) != 0)
+			{
+				DBG1(DBG_NET, "changing group for '%s' failed: %s",
+					 this->filename, strerror(errno));
+			}
+		}
+#endif /* HAVE_CHOWN */
 #ifdef HAVE_SETLINEBUF
 		if (flush_line)
 		{
